/*----------------------------------------------------------------------------*/
// Verilog Configurable_IC62411
// 2015 7 12 1 9 8
// Created By "Altium Configurable Verilog Generator"
// "Copyright (c) 2002-20010 Altium Limited"
/*----------------------------------------------------------------------------*/

module Configurable_IC62411(
Q,
CLR,
CEO,
TC,
CE,
C );

output [16:0] Q   ;
input CLR ;
output CEO ;
output TC  ;
input CE  ;
input C   ;


/*----------------------------------------------------------------------------*/
parameter cMaxValue = 17'b11000011010100000;
parameter cMinValue = 0;
/*----------------------------------------------------------------------------*/

reg [16:0]Y = cMinValue;
reg [16:0]Y_Init = cMinValue;
wire TC_int;

    // synthesis translate_off
    always @( CLR )
    begin
        if (CLR == 1'b1) begin
            force Y = cMinValue;
        end else begin
            release Y;
        end
    end
    // synthesis translate_on
    
    always @( posedge C or posedge CLR )
    begin
        if (CLR == 1'b1) begin
            Y <= cMinValue;
        end else begin
            if (CE == 1'b1) begin
                if (Y >= cMaxValue)
                    Y <= cMinValue;
                else
                    Y <= Y + 1;
                
            end
        end
    end

assign TC_int = (Q == cMaxValue)?1:0;
assign Q = Y;
assign TC  = TC_int;
assign CEO = TC_int & CE;

endmodule
/*----------------------------------------------------------------------------*/

